/* debug.c : permet d'crire les erreurs et les info de debuggage dans un fichier */

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *\
 * UltimateTetris                           Copyright (C) 2001, AnTiKoNs *
 *----------------/                                                      *
 * This program is free software; you can redistribute it and/or modify  *
 * it under the terms of the GNU General Public License as published by  *
 * the Free Software Foundation; either version 2 of the License, or     *
 * (at your option) any later version.                                   *
 *                                                                       *
 * This program is distributed in the hope that it will be useful,       *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 * GNU General Public License for more details.                          *
 *                                                                       *
 * The author of this program may be contacted at antikons@ifrance.com   *
 *                                                                       *
\* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

#include <windows.h>
#include <stdio.h>
#include <stdarg.h>


// Indique une erreur
void Error( const char *format, ... )
{
	va_list args;
	char buf[1024];
	FILE *f;
	
	va_start(args, format);
	
	_vsnprintf(buf, 1024, format, args);
	
	va_end(args);
	
	OutputDebugString("ERROR : ");
	OutputDebugString(buf);
	OutputDebugString("\n");
	
	f = fopen("DEBUG.LOG", "a+");
	if(f)
	{
		fprintf(f,"ERROR : %s\n", buf );
		fclose(f);
	}
}


// Indique une info de debuggage
void Debug( const char *format, ... )
{
	va_list args;
	char buf[1024];
	FILE *f;
	
	va_start(args, format);
	
	_vsnprintf(buf, 1024, format, args);
	
	va_end(args);
	
	OutputDebugString("DEBUG : ");
	OutputDebugString(buf);
	OutputDebugString("\n");
	
	f = fopen("DEBUG.LOG", "a+");
	if(f)
	{
		fprintf(f,"DEBUG : %s\n", buf );
		fclose(f);
	}
}