/* ds.c : Fonctions DirectSound non spcifiques au jeu */

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *\
 * UltimateTetris                           Copyright (C) 2001, AnTiKoNs *
 *----------------/                                                      *
 * This program is free software; you can redistribute it and/or modify  *
 * it under the terms of the GNU General Public License as published by  *
 * the Free Software Foundation; either version 2 of the License, or     *
 * (at your option) any later version.                                   *
 *                                                                       *
 * This program is distributed in the hope that it will be useful,       *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 * GNU General Public License for more details.                          *
 *                                                                       *
 * The author of this program may be contacted at antikons@ifrance.com   *
 *                                                                       *
\* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

#include <dsound.h>
#include "main.h"
#include "dsutil.h"


LPDIRECTSOUND g_lpDS = NULL;				// Objet DirectSound


// Initialisation de DirectSound
BOOL DSInit(void)
{
	HRESULT		hr;		//The return result
	
	// Create DirectSound.
	hr = DirectSoundCreate( NULL, &g_lpDS, NULL );
	if(!DSCheck(hr, "DSInit : DirectSoundCreate"))
		return FALSE;
	
	// Set cooperative level.
	hr = IDirectSound_SetCooperativeLevel( g_lpDS, g_hWnd, DSSCL_PRIORITY );
	if(!DSCheck(hr, "DSInit : SetCooperativeLevel"))
		return FALSE;
	
	return TRUE;
}


// Fermeture de DirectSound
void DSClose(void)
{
	// Dtruit les objets
	if( g_lpDS )
	{
		IDirectSound_Release( g_lpDS );
		g_lpDS = NULL;
	}
}
