/* game.c : gestion du jeu de Tetris */

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *\
 * UltimateTetris                           Copyright (C) 2001, AnTiKoNs *
 *----------------/                                                      *
 * This program is free software; you can redistribute it and/or modify  *
 * it under the terms of the GNU General Public License as published by  *
 * the Free Software Foundation; either version 2 of the License, or     *
 * (at your option) any later version.                                   *
 *                                                                       *
 * This program is distributed in the hope that it will be useful,       *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 * GNU General Public License for more details.                          *
 *                                                                       *
 * The author of this program may be contacted at antikons@ifrance.com   *
 *                                                                       *
\* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

#include <stdlib.h>
#include <time.h>
#include <memory.h>
#include "sounds.h"
#include "skins.h"
#include "config.h"


//Est-ce que le jeu est en pause
BOOL g_bPause = FALSE;

//La matrice qui affiche GAME OVER avec des briques de tetris
static int go[10][18] = {
	2,2,2,2,0,0,0,0,0,0,5,5,5,0,0,0,0,0,
	2,0,0,2,0,4,4,4,4,0,5,0,5,0,0,0,0,0,
	2,0,2,2,0,0,4,0,0,0,5,5,5,0,0,0,0,0,
	0,0,0,0,0,0,0,4,0,0,0,0,0,1,1,1,1,1,
	0,0,0,0,0,0,4,0,0,0,0,0,0,1,0,1,0,1,
	0,0,0,0,0,4,4,4,4,0,6,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0,0,0,0,6,0,0,7,7,7,7,
	1,1,1,1,0,3,3,3,3,3,0,0,6,0,0,7,0,0,
	1,0,1,0,0,3,0,3,0,3,0,6,0,0,7,0,0,0,
	1,1,1,1,0,0,0,0,0,0,6,0,0,0,0,0,0,0
};

//Les blocks  dessiner (= blocks + cur_piece)
int g_blocks2draw[10][18];

//Les blocks dj tombs
static int blocks[10][18];

//La prochaine pice
int g_next[4][4];

int g_score;
int g_lines;
int g_best;
int g_level;
int g_speed = 1;
unsigned int g_uTimer = 500;
static int gameover;


typedef struct PIECE
{
	int width;
	int height;
	char *array;
} PIECE;

static PIECE pieces[7][4];

static int cur_piece;
static int cur_pos;
static int cur_x;
static int cur_y;
static int next_piece;
static int next_pos;

static int is_init = 0;

static int must_putpiece = 0;


static void InitPieces(void)
{
	//piece1
	pieces[0][0].width=3;
	pieces[0][0].height=2;
	pieces[0][0].array="\0\1\0"
                       "\1\1\1";

	pieces[0][1].width=2;
	pieces[0][1].height=3;
	pieces[0][1].array="\0\1"
                       "\1\1"
                       "\0\1";
	
	pieces[0][2].width=3;
	pieces[0][2].height=2;
	pieces[0][2].array="\1\1\1"
                       "\0\1\0";
	
	pieces[0][3].width=2;
	pieces[0][3].height=3;
	pieces[0][3].array="\1\0"
                       "\1\1"
                       "\1\0";
	
	//piece2
	pieces[1][0].width=3;
	pieces[1][0].height=2;
	pieces[1][0].array="\2\2\0"
                       "\0\2\2";

	pieces[1][1].width=2;
	pieces[1][1].height=3;
	pieces[1][1].array="\0\2"
                       "\2\2"
                       "\2\0";

	pieces[1][2]=pieces[1][0];
	pieces[1][3]=pieces[1][1];
	
	//piece3
	pieces[2][0].width=3;
	pieces[2][0].height=2;
	pieces[2][0].array="\0\3\3"
                       "\3\3\0";

	pieces[2][1].width=2;
	pieces[2][1].height=3;
	pieces[2][1].array="\3\0"
                       "\3\3"
                       "\0\3";

	pieces[2][2]=pieces[2][0];
	pieces[2][3]=pieces[2][1];
	
	//piece4
	pieces[3][0].width=3;
	pieces[3][0].height=2;
	pieces[3][0].array="\4\0\0"
                       "\4\4\4";

	pieces[3][1].width=2;
	pieces[3][1].height=3;
	pieces[3][1].array="\0\4"
                       "\0\4"
                       "\4\4";
	
	pieces[3][2].width=3;
	pieces[3][2].height=2;
	pieces[3][2].array="\4\4\4"
                       "\0\0\4";
	
	pieces[3][3].width=2;
	pieces[3][3].height=3;
	pieces[3][3].array="\4\4"
                       "\4\0"
                       "\4\0";
	
	//piece5
	pieces[4][0].width=3;
	pieces[4][0].height=2;
	pieces[4][0].array="\0\0\5"
                       "\5\5\5";

	pieces[4][1].width=2;
	pieces[4][1].height=3;
	pieces[4][1].array="\5\5"
                       "\0\5"
                       "\0\5";
	
	pieces[4][2].width=3;
	pieces[4][2].height=2;
	pieces[4][2].array="\5\5\5"
                       "\5\0\0";
	
	pieces[4][3].width=2;
	pieces[4][3].height=3;
	pieces[4][3].array="\5\0"
                       "\5\0"
                       "\5\5";

	//piece6
	pieces[5][0].width=2;
	pieces[5][0].height=2;
	pieces[5][0].array="\6\6"
                       "\6\6";

	pieces[5][1]=pieces[5][0];
	pieces[5][2]=pieces[5][0];
	pieces[5][3]=pieces[5][0];

	//piece7
	pieces[6][0].width=4;
	pieces[6][0].height=1;
	pieces[6][0].array="\7\7\7\7";
	
	pieces[6][1].width=1;
	pieces[6][1].height=4;
	pieces[6][1].array="\7"
                       "\7"
                       "\7"
					   "\7";
	
	pieces[6][2]=pieces[6][0];
	pieces[6][3]=pieces[6][1];
}

static void UpdateNext(void)
{
	int x,y;
	PIECE *piece = &pieces[next_piece][next_pos];

	memset(g_next,0,sizeof(g_next));
	for(x=0;x<piece->width;x++)
	{
		for(y=0;y<piece->height;y++)
		{
			g_next[x][y] = piece->array[y*(piece->width)+x];
		}
	}
}

static void NewPiece(void)
{
	cur_piece = next_piece;
	cur_pos = next_pos;
	cur_x=3;
	cur_y=0;
	next_piece = (rand()*7)/RAND_MAX;
	next_pos = (rand()*4)/RAND_MAX;
	UpdateNext();
}

static void CalculateTimer(void)
{
	g_uTimer = 1100 - g_speed * 100;
}

static void InitGame(void)
{
	memset(blocks,0,sizeof(blocks));
	memset(g_next,0,sizeof(g_next));
	
	g_score = 0;
	g_lines = 0;
	
	InitPieces();
	
	srand((unsigned)time(NULL));
	
	next_piece = (rand()*7)/RAND_MAX;
	next_pos = (rand()*4)/RAND_MAX;

	NewPiece();
	
	gameover = 0;
	must_putpiece = 0;
	CalculateTimer();
	
	is_init = 1;
}

static void GameOver(void)
{
	gameover = 1;
	g_uTimer = 1500;
	memcpy(g_blocks2draw,go,sizeof(g_blocks2draw));
	if(g_score>g_best)
	{
		g_best = g_score;
		SaveConfig();
	}
}

static int CheckLines(void)
{
	char x, y, line, c = 0;
	
	for(y=0;y<18;y++)
	{
		if((blocks[0][y]!=0)&&(blocks[1][y]!=0)&&(blocks[2][y]!=0)&&(blocks[3][y]!=0)&&(blocks[4][y]!=0)&&(blocks[5][y]!=0)&&(blocks[6][y]!=0)&&(blocks[7][y]!=0)&&(blocks[8][y]!=0)&&(blocks[9][y]!=0))
		{
			c++;
			PlayDestroy();
			for(line=y;line>1;line--)
				for(x=0;x<10;x++)
					blocks[x][line]=blocks[x][line-1];
		}
	}
	return c;
}

static void CheckScore(void)
{
	if(!(g_score%10000))
	{
		g_score += 400;
		g_speed++;
		if(g_speed>10)
		{
			g_speed = 10;
		}
		CalculateTimer();
	}
}

static void PutPiece(void)
{
	int x,y;
	char color;
	PIECE *piece = &pieces[cur_piece][cur_pos];
	
	PlayDrop();
	if(cur_y==0)GameOver();
	for(x=0;x<piece->width;x++)
		for(y=0;y<piece->height;y++)
		{
			color = piece->array[y*(piece->width)+x];
			if(color!=0)
				blocks[cur_x+x][cur_y+y]=color;
		}
	switch(CheckLines())
	{
	case 0:
		break;
	case 1:
		g_score += 100;
		g_lines++;
		CheckScore();
		break;
	case 2:
		g_score += 300;
		g_lines += 2;
		CheckScore();
		break;
	case 3:
		g_score += 700;
		g_lines += 3;
		CheckScore();
		break;
	case 4:
		g_score += 1500;
		g_lines += 4;
		CheckScore();
	}
}

static int CheckCurPiece(void)
{
	int x,y;
	PIECE *piece = &pieces[cur_piece][cur_pos];

	if(cur_y+piece->height>18)
		return 0;
	for(x=0;x<piece->width;x++)
		for(y=0;y<piece->height;y++)
			if((blocks[cur_x+x][cur_y+y]!=0)&&(piece->array[y*(piece->width)+x]!=0))
				return 0;
	return 1;
}

static void Down(void)
{
	cur_y++;
	if(CheckCurPiece())
		return;
	else
	{
		cur_y--;
		must_putpiece = 1;
/*		PutPiece();
		NewPiece();*/
	}
}

static void Left(void)
{
	if(cur_x>0)
		cur_x--;
	else
		return;
	if(!CheckCurPiece())
		cur_x++;
	else
		PlayMove();
}

static void Right(void)
{

	if(cur_x<10-pieces[cur_piece][cur_pos].width)
		cur_x++;
	else
		return;
	if(!CheckCurPiece())
		cur_x--;
	else
		PlayMove();
}

static void Turn(void)
{
	cur_pos++;
	if(cur_pos>3)cur_pos=0;
	//vrifier que le mur n'empeche pas la piece de tourner
	if((cur_x+pieces[cur_piece][cur_pos].width>10)||(!CheckCurPiece()))
	{
		cur_pos--;
		if(cur_pos<0)cur_pos=3;
	}
	else
	{
		PlayTurn();
	}
}

static void UpdateBlocks2Draw(void)
{
	int x,y;
	char color;
	PIECE *piece = &pieces[cur_piece][cur_pos];
	
	memcpy(g_blocks2draw,blocks,sizeof(blocks));
	
	for(x=0;x<piece->width;x++)
		for(y=0;y<piece->height;y++)
		{
			color = piece->array[y*(piece->width)+x];
			if(color)
			{
				g_blocks2draw[cur_x+x][cur_y+y] = color;
			}
		}
}

static void BuildLevel(void)
{
	int x, y, blank, block, c;
	
	for( y = 17 ; y > 17 - g_level ; y-- )
	{
		for( x = 0, blank = 0, block = 0 ; x < 10 ; x++ )
		{
			c = (rand()*6)/RAND_MAX+1;
			if((rand()*2)/RAND_MAX)
			{
				c = 0;
			}
			blocks[x][y] = c;
			if(!c) blank = 1;
			else block = 1;
		}
		if(!blank)
		{
			blocks[0][y] = 0;
		}
		if(!block)
		{
			blocks[0][y] = 1;
		}
	}
}

static int CheckCurPieceIfDown(void)
{
	int r;

	cur_y++;
	r = CheckCurPiece();
	cur_y--;
	return r;
}

void GameLoop(void)
{
	if(!is_init)
	{
		InitGame();
		gameover = 3;
		memset(g_blocks2draw,0,sizeof(g_blocks2draw));
		return;
	}
	if(gameover)
	{
		switch(gameover)
		{
		case 1:
			UpdateBlocks2Draw();
			gameover = 2;
			return;
		case 2:
			memcpy(g_blocks2draw,go,sizeof(g_blocks2draw));
			gameover = 1;
			return;
		case 3:
			return;
		}
	}
	if((must_putpiece)&&(!CheckCurPieceIfDown()))
	{
		PutPiece();
		NewPiece();
		must_putpiece = 0;
		return;
	}
	UpdateBlocks2Draw();
	Down();
}

void OnKeyLeft(void)
{
	if((gameover)||(g_bPause))
		return;
	Left();
	UpdateBlocks2Draw();
}

void OnKeyRight(void)
{
	if((gameover)||(g_bPause))
		return;
	Right();
	UpdateBlocks2Draw();
}

void OnKeyUp(void)
{
	if((gameover)||(g_bPause))
		return;
	Turn();
	UpdateBlocks2Draw();
}

void OnKeyDown(void)
{
	if((gameover)||(g_bPause))
		return;
	Down();
	if((must_putpiece)&&(!CheckCurPieceIfDown()))
	{
		PutPiece();
		NewPiece();
		must_putpiece = 0;
	}
	if(gameover)
		return;
	UpdateBlocks2Draw();
}

void OnKeyReturn(void)
{
	if((gameover)&&(!g_bPause))
	{
		InitGame();
		BuildLevel();
	}
}

void OnKeyF1(void)
{
	if(gameover)
	{
		if(g_level>0)
			g_level--;
		else
			g_level = 10;
	}
}

void OnKeyF2(void)
{
	if(gameover)
	{
		if(g_level<10)
			g_level++;
		else
			g_level = 0;
	}
}

void OnKeyF3(void)
{
	if(gameover)
	{
		if(g_speed>1)
			g_speed--;
		else
			g_speed = 10;
	}
}

void OnKeyF4(void)
{
	if(gameover)
	{
		if(g_speed<10)
			g_speed++;
		else
			g_speed = 1;
	}
}

void OnKeyF5(void)
{
	SkinsPrev();
}

void OnKeyF6(void)
{
	SkinsNext();
}

void OnKeyF7(void)
{
	g_bSounds = !g_bSounds;
}

void OnKeyF8(void)
{
	g_bPause = !g_bPause;
}
