/* key.c : Gestion du clavier */

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *\
 * UltimateTetris                           Copyright (C) 2001, AnTiKoNs *
 *----------------/                                                      *
 * This program is free software; you can redistribute it and/or modify  *
 * it under the terms of the GNU General Public License as published by  *
 * the Free Software Foundation; either version 2 of the License, or     *
 * (at your option) any later version.                                   *
 *                                                                       *
 * This program is distributed in the hope that it will be useful,       *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 * GNU General Public License for more details.                          *
 *                                                                       *
 * The author of this program may be contacted at antikons@ifrance.com   *
 *                                                                       *
\* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

#include <dinput.h>
#include "diutil.h"
#include "di.h"
#include "game.h"


#define KEYDOWN(name,key) (name[key] & 0x80) 


//Dlais de rpetitions (en millisecondes)
#define REPEAT_DELAY_MOVE	100		/* Mouvement (gauche ou droite) */
#define REPEAT_DELAY_TURN	500		/* Rotation (touche du haut) */
#define REPEAT_DELAY_DROP	40		/* Drop (touche du bas) */


//Permet de compter le temps pour les dlais de rptition
static DWORD					dwMoveTime = 0, dwTurnTime = 0, dwDropTime = 0;
//Est-ce que la touche xxx est enfonce
static BOOL					isKeyUpDown = FALSE;
static BOOL					isKeyReturnDown = FALSE;
static BOOL					isKeyF1Down = FALSE;
static BOOL					isKeyF2Down = FALSE;
static BOOL					isKeyF3Down = FALSE;
static BOOL					isKeyF4Down = FALSE;
static BOOL					isKeyF5Down = FALSE;
static BOOL					isKeyF6Down = FALSE;
static BOOL					isKeyF7Down = FALSE;
static BOOL					isKeyF8Down = FALSE;


//Lit l'tat du clavier et excute les fonction OnKeyXXXDown si ncessaire
void DIProcessKBInput(void)
{
	char buffer[256];
	
    if(FAILED(
		IDirectInputDevice_GetDeviceState( g_lpDIDev, sizeof(buffer), (LPVOID)&buffer )
		))
		return;
	
    //<Left> & <Right>
    if (KEYDOWN(buffer, DIK_RIGHT))
	{
		if( GetTickCount() - dwMoveTime < REPEAT_DELAY_MOVE )
		{
			return;
		}
		dwMoveTime = GetTickCount();
		OnKeyRight();
	}
    else if(KEYDOWN(buffer, DIK_LEFT))
	{
		if( GetTickCount() - dwMoveTime < REPEAT_DELAY_MOVE )
		{
			return;
		}
		dwMoveTime = GetTickCount();
		OnKeyLeft();
	}

	//<Up>
    if(KEYDOWN(buffer, DIK_UP))
	{
		if(( GetTickCount() - dwTurnTime < REPEAT_DELAY_TURN )&&( isKeyUpDown ))
		{
			return;
		}
		dwTurnTime = GetTickCount();
		OnKeyUp();
		isKeyUpDown = TRUE;
	}
	else
	{
		isKeyUpDown = FALSE;
	}
    
	//<Down>
	if(KEYDOWN(buffer, DIK_DOWN))
	{
		if( GetTickCount() - dwDropTime < REPEAT_DELAY_DROP )
		{
			return;
		}
		dwDropTime = GetTickCount();
		OnKeyDown();
	}
	
	//<Return>
	if(KEYDOWN(buffer, DIK_RETURN))
	{
		if( isKeyReturnDown )
		{
			return;
		}
		OnKeyReturn();
		isKeyReturnDown = TRUE;
	}
	else
	{
		isKeyReturnDown = FALSE;
	}
	
	//F1
	if(KEYDOWN(buffer, DIK_F1))
	{
		if( isKeyF1Down )
		{
			return;
		}
		OnKeyF1();
		isKeyF1Down = TRUE;
	}
	else
	{
		isKeyF1Down = FALSE;
	}

	//F2
	if(KEYDOWN(buffer, DIK_F2))
	{
		if( isKeyF2Down )
		{
			return;
		}
		OnKeyF2();
		isKeyF2Down = TRUE;
	}
	else
	{
		isKeyF2Down = FALSE;
	}
	
	//F3
	if(KEYDOWN(buffer, DIK_F3))
	{
		if( isKeyF3Down )
		{
			return;
		}
		OnKeyF3();
		isKeyF3Down = TRUE;
	}
	else
	{
		isKeyF3Down = FALSE;
	}
	
	//F4
	if(KEYDOWN(buffer, DIK_F4))
	{
		if( isKeyF4Down )
		{
			return;
		}
		OnKeyF4();
		isKeyF4Down = TRUE;
	}
	else
	{
		isKeyF4Down = FALSE;
	}
	
	//F5
	if(KEYDOWN(buffer, DIK_F5))
	{
		if( isKeyF5Down )
		{
			return;
		}
		OnKeyF5();
		isKeyF5Down = TRUE;
	}
	else
	{
		isKeyF5Down = FALSE;
	}
	
	//F6
	if(KEYDOWN(buffer, DIK_F6))
	{
		if( isKeyF6Down )
		{
			return;
		}
		OnKeyF6();
		isKeyF6Down = TRUE;
	}
	else
	{
		isKeyF6Down = FALSE;
	}
	
	//F7
	if(KEYDOWN(buffer, DIK_F7))
	{
		if( isKeyF7Down )
		{
			return;
		}
		OnKeyF7();
		isKeyF7Down = TRUE;
	}
	else
	{
		isKeyF7Down = FALSE;
	}
	
	//F8
	if(KEYDOWN(buffer, DIK_F8))
	{
		if( isKeyF8Down )
		{
			return;
		}
		OnKeyF8();
		isKeyF8Down = TRUE;
	}
	else
	{
		isKeyF8Down = FALSE;
	}
}
