/* wave.h : Fichier pour charger un wave  partir d'un fichier ou d'une resource */

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *\
 * UltimateTetris                           Copyright (C) 2001, AnTiKoNs *
 *----------------/                                                      *
 * This program is free software; you can redistribute it and/or modify  *
 * it under the terms of the GNU General Public License as published by  *
 * the Free Software Foundation; either version 2 of the License, or     *
 * (at your option) any later version.                                   *
 *                                                                       *
 * This program is distributed in the hope that it will be useful,       *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 * GNU General Public License for more details.                          *
 *                                                                       *
 * The author of this program may be contacted at antikons@ifrance.com   *
 *                                                                       *
\* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

#ifndef __INC_WAVE_H
#define __INC_WAVE_H


#include <windows.h>


#ifdef __cplusplus
extern "C" {
#endif

#define WAVEVERSION 1

#ifndef ER_MEM
#define ER_MEM 				0xe000
#endif

#ifndef ER_CANNOTOPEN
#define ER_CANNOTOPEN 		0xe100
#endif

#ifndef ER_NOTWAVEFILE
#define ER_NOTWAVEFILE 		0xe101
#endif

#ifndef ER_CANNOTREAD
#define ER_CANNOTREAD 		0xe102
#endif

#ifndef ER_CORRUPTWAVEFILE
#define ER_CORRUPTWAVEFILE	0xe103
#endif

#ifndef ER_CANNOTWRITE
#define ER_CANNOTWRITE		0xe104
#endif



int WaveOpenFile(TCHAR*, HMMIO *, WAVEFORMATEX **, MMCKINFO *);	// Ouvre un fichier wave
int WaveStartDataRead(HMMIO *, MMCKINFO *, MMCKINFO *);			// Commence la lecture
int WaveReadFile(HMMIO, UINT, BYTE *, MMCKINFO *, UINT *);		// Lit un morceau du fichier
int WaveCloseReadFile(HMMIO *, WAVEFORMATEX **);				// Ferme un fichier wave
int WaveLoadFile(TCHAR*, UINT *, WAVEFORMATEX **, BYTE **);		// Charge un fichier dans son intgralit


#ifdef __cplusplus
}
#endif //__cplusplus


#endif //__INC_WAVE_H
